//---
#include "..\MultiSymbolPriceDivergence.mq5"
#include "Checks.mqh"
#include "Objects.mqh"
//---
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
void SetBarsColors()
  {
//---   ,      
   ChartSetInteger(0,CHART_COLOR_CHART_UP,color_bar_up);
//---    
   ChartSetInteger(0,CHART_COLOR_CANDLE_BULL,color_bar_up);
//---       ""
   ChartSetInteger(0,CHART_COLOR_CHART_LINE,color_bar_up);
//---    
   if(TwoColor)
     {
      //---   ,      
      ChartSetInteger(0,CHART_COLOR_CHART_DOWN,color_bar_down);
      //---    
      ChartSetInteger(0,CHART_COLOR_CANDLE_BEAR,color_bar_down);
     }
//---    
   else
     {
      //---   ,      
      ChartSetInteger(0,CHART_COLOR_CHART_DOWN,color_bar_up);
      //---    
      ChartSetInteger(0,CHART_COLOR_CANDLE_BEAR,color_bar_up);
     }
  }
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
void GetWindowGeometry()
  {
//---    
   window_number=ChartWindowFind(0,indicator_shortname);
//---     
   chart_width=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS);
   chart_height=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,window_number);
//---    
   chart_center_x=chart_width/2;
   chart_center_y=chart_height/2;
  }
//+------------------------------------------------------------------+
//|  /      |
//+------------------------------------------------------------------+
void CorrectChartMaxMin()
  {
   double low[];                  //  
   double high[];                 //  
   int    attempts          =10;  // - 
   int    array_size        =0;   //    
   int    visible_bars      =0;   //   
   int    first_visible_bar =0;   //    
   int    last_visible_bar  =0;   //    
   double max_price         =0.0; //  
   double min_price         =0.0; //  
   double offset_max_min    =0.0; //   / 
//---   
   ResetLastError();
//---   
   visible_bars=(int)ChartGetInteger(0,CHART_VISIBLE_BARS);
//---    
   first_visible_bar=(int)ChartGetInteger(0,CHART_FIRST_VISIBLE_BAR);
//---    
   last_visible_bar=first_visible_bar-visible_bars;
//---   , 
   if(GetLastError()!=0)
      return;
//---   , 
   if(last_visible_bar<0)
      last_visible_bar=0;
//---          
   for(int i=0; i<attempts; i++)
      if(CopyHigh(Symbol(),Period(),last_visible_bar,visible_bars,high)==visible_bars)
         break;
   for(int i=0; i<attempts; i++)
      if(CopyLow(Symbol(),Period(),last_visible_bar,visible_bars,low)==visible_bars)
         break;
//--- ,     
   if(ArraySize(high)<=0 || ArraySize(low)<=0)
      return;
//---   ,        
   else
     {
      min_price=low[ArrayMinimum(low)];
      max_price=high[ArrayMaximum(high)];
     }
//---         
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---    ,    
      if(symbol_names[s]==empty_symbol)
         continue;
      //---
      datetime time[];         //  
      int      bars_count=0; //    
      //---    
      ArrayResize(high,0);
      ArrayResize(low,0);
      //---       
      for(int i=0; i<attempts; i++)
         if(CopyTime(Symbol(),Period(),last_visible_bar,visible_bars,time)==visible_bars)
            break;
      //---   ,     , 
      if(ArraySize(time)<visible_bars)
         return;
      //---    ""  , 
      //         , 
      //           
      if(limit_time[s]>time[0])
        {
         //---   
         array_size=ArraySize(time);
         //---      
         if((bars_count=Bars(Symbol(),Period(),limit_time[s],time[array_size-1]))<=0)
            return;
        }
      //---       
      else
         bars_count=visible_bars;
      //---  ,   
      ArraySetAsSeries(low,true);
      ArraySetAsSeries(high,true);
      //---     
      //       
      if(DrawType!=LINE)
        {
         ArrayCopy(low,buffer_data[s].low);
         ArrayCopy(high,buffer_data[s].high);
        }
      //---    
      else
        {
         ArrayCopy(low,buffer_data[s].close);
         ArrayCopy(high,buffer_data[s].close);
        }
      //---   
      array_size=ArraySize(high);
      //---   ,
      //          /
      for(int i=0; i<array_size; i++)
        {
         if(high[i]==EMPTY_VALUE)
            high[i]=max_price;
         if(low[i]==EMPTY_VALUE)
            low[i]=min_price;
        }
      //---  /  
      if(inverse[s])
        {
         //---   ,  
         if(ArrayMaximum(high,last_visible_bar,bars_count)>=0 && 
            ArrayMinimum(low,last_visible_bar,bars_count)>=0)
           {
            max_price=fmax(max_price,low[ArrayMaximum(low,last_visible_bar,bars_count)]);
            min_price=fmin(min_price,high[ArrayMinimum(high,last_visible_bar,bars_count)]);
           }
        }
      else
        {
         //---   ,  
         if(ArrayMinimum(low,last_visible_bar,bars_count)>=0 && 
            ArrayMaximum(high,last_visible_bar,bars_count)>=0)
           {
            min_price=fmin(min_price,low[ArrayMinimum(low,last_visible_bar,bars_count)]);
            max_price=fmax(max_price,high[ArrayMaximum(high,last_visible_bar,bars_count)]);
           }
        }
     }
//---   (3%)     
   offset_max_min=((max_price-min_price)*3)/100;
//---     
   ChartSetInteger(0,CHART_SCALEFIX,true);
//---  /
   ChartSetDouble(0,CHART_FIXED_MAX,max_price+offset_max_min);
   ChartSetDouble(0,CHART_FIXED_MIN,min_price-offset_max_min);
//---  
   ChartRedraw();
  }
//+------------------------------------------------------------------+
