//---
#include "..\MultiSymbolPriceDivergence.mq5"
#include "Chart.mqh"
#include "Checks.mqh"
//---
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
void SetDivergenceLine()
  {
//---    ,  
   if(StartPriceDivergence==VERTICAL_LINE && ObjectFind(0,start_price_divergence)<0)
      //---      
      CreateVerticalLine(0,0,TimeCurrent()+PeriodSeconds(),start_price_divergence,
                         2,STYLE_SOLID,clrGreenYellow,true,true,false,"","\n");
//---      
   if(StartPriceDivergence!=VERTICAL_LINE)
      DeleteObjectByName(start_price_divergence);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void CreateVerticalLine(long            chart_id,         // id 
                        int            _window_number,    //  
                        datetime        time,             // 
                        string          object_name,      //  
                        int             line_width,       //  
                        ENUM_LINE_STYLE line_style,       //  
                        color           line_color,       //  
                        bool            selected,         //  
                        bool            selectable,       //   ,  FALSE
                        bool            back,             //     
                        string          description_text, //  
                        string          tooltip)          //   ,  "\n"
  {
//---    
   if(ObjectCreate(chart_id,object_name,OBJ_VLINE,_window_number,time,0))
     {
      //   
      ObjectSetInteger(chart_id,object_name,OBJPROP_TIME,time);
      ObjectSetInteger(chart_id,object_name,OBJPROP_STYLE,line_style);
      ObjectSetInteger(chart_id,object_name,OBJPROP_WIDTH,line_width);
      ObjectSetInteger(chart_id,object_name,OBJPROP_COLOR,line_color);
      ObjectSetInteger(chart_id,object_name,OBJPROP_SELECTABLE,selectable);
      ObjectSetInteger(chart_id,object_name,OBJPROP_SELECTED,selected);
      ObjectSetInteger(chart_id,object_name,OBJPROP_BACK,back);
      ObjectSetString(chart_id,object_name,OBJPROP_TEXT,description_text);
      ObjectSetString(chart_id,object_name,OBJPROP_TOOLTIP,tooltip);
     }
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void DeleteObjectByName(string object_name)
  {
//---    
   if(ObjectFind(0,object_name)>=0)
     {
      //---     ,   
      if(!ObjectDelete(0,object_name))
         Print(" ("+IntegerToString(GetLastError())+")   !");
     }
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void DeleteVerticalLines()
  {
   string object_name="";           //  
   int    vertical_lines_count=0;   //   
//---    
   vertical_lines_count=ObjectsTotal(0,0,OBJ_VLINE);
//---   ,     
   for(int i=vertical_lines_count-1; i>=0; i--)
     {
      //---   
      for(int j=0; j<5; j++)
         if((object_name=ObjectName(0,i))!="")
            break;
      //---      ,  
      if(StringFind(object_name,prefix,0)>-1)
         DeleteObjectByName(object_name);
     }
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
void DeleteCanvas()
  {
//---  ,   
   if(ObjectFind(0,canvas_name)==0)
     {
      //---     
      for(int i=canvas_opacity; i>0; i-=5)
        {
         canvas.Erase(ColorToARGB(canvas_background,(uchar)i));
         canvas.Update();
        }
      //---   
      canvas.Destroy();
     }
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void SetCanvas()
  {
//---   ,  
   if(ObjectFind(0,canvas_name)<0)
     {
      //---  
      canvas.CreateBitmapLabel(0,window_number,canvas_name,0,0,chart_width,chart_height,clr_format);
      //---    
      canvas.Erase(ColorToARGB(canvas_background,0));
      //---  
      canvas.Update();
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void ShowCanvasMessage(string message_text)
  {
   GetWindowGeometry();
//---       
   if(ObjectFind(0,canvas_name)==window_number)
     {
      //---        ,  
      if(message_text!="" && chart_center_x>0 && chart_center_y>0)
        {
         canvas.Erase(ColorToARGB(canvas_background,canvas_opacity));
         canvas.TextOut(chart_center_x,chart_center_y,message_text,ColorToARGB(clrRed),TA_CENTER|TA_VCENTER);
         canvas.Update();
        }
     }
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void ResizeCanvas()
  {
//---       ,   
   if(ObjectFind(0,canvas_name)==window_number)
      canvas.Resize(chart_width,chart_height);
  }
//+------------------------------------------------------------------+
